//C <-> Ruby conversion functions
//Only code which can not be written in C# (macro dependant code)
//is put here.

#include <ruby.h>
//For debugging
#include <stdio.h> 

//Ruby -> C

//VALUE -> Int32 array
int * val_to_int_array(VALUE v)
{
  ///Don't use malloc, the arrays we use fit on the stack
  int arr[RARRAY(v)->len];
  int x;

  //Ruby arrays are a bit tricky, what I do is loop, then convert every
  //element into a C# data type
  for (x = 0; x < RARRAY(v)->len; x++) {
    arr[x] = NUM2INT(RARRAY(v)->ptr[x]) ;
  }
  return arr;
};

//VALUE -> String array
char ** val_to_str_array(VALUE v)
{
  //Don't use malloc, the arrays we use fit on the stack
  char ** arr;
  int x;
  
  //Ruby arrays are a bit tricky, what I do is loop, then convert every
  //element into a C# data type
  for (x = 0; x < RARRAY(v)->len; x++) {
     arr[x] = RSTRING(rb_ary_shift(RARRAY(v)->ptr));
   }
};

//Note: it's not possible to convert a FIXNUM into anything else
//than a Int32

//VALUE -> Int32 (signed 32 bits integer)
int * val_to_int(VALUE v)
{
  return FIX2INT(v);
};

//VALUE -> String
char * val_to_str(VALUE v)
{
  return RSTRING(v)->ptr;
};
